unit main;

{$mode objfpc}{$H+}

interface

uses
  Forms, Controls, Menus, ExtCtrls, Xscontrols,
  LCLType, LCLIntf, Classes, Graphics, Dialogs,
  SysUtils, FileUtil, DockManager, Clipbrd, StdCtrls, Buttons;

const
  tb_sep = 0;
  tb_new = 1;       tb_open = 2;
  tb_save = 3;      tb_saveall = 4;   tb_saveas = 5;
  tb_cut = 6;       tb_copy = 7;      tb_paste = 8;     tb_del = 9;
  tb_undo = 10;     tb_redo = 11;
  tb_find = 12;     tb_findprev = 13; tb_findnext = 14;
  tb_unindent = 15; tb_indent = 16;
  tb_setting = 17;  tb_options = 18;
  tb_build = 19;    tb_run = 20;      tb_pause = 21;    tb_stop = 22;
  tb_print = 23;    tb_color = 24;
  tb_exit = 25;

  pm_closepage = 29;pm_selall = 30;   pm_delsel = 31;
  pm_upper = 32;    pm_lower = 33;    pm_swap = 34;     pm_title = 35;

  tlbtn : array [0..33] of smallint = (
    tb_new,tb_open,tb_sep,
    tb_save,tb_saveall,tb_saveas,tb_sep,
    tb_cut,tb_copy,tb_paste,tb_del,tb_sep,
    tb_undo,tb_redo,tb_sep,
    tb_find,tb_findprev,tb_findnext,tb_sep,
    tb_unindent,tb_indent,tb_sep,
    tb_setting,tb_options,tb_sep,
    tb_build,tb_run,tb_pause,tb_stop,tb_sep,
    tb_print,tb_color,tb_sep,
    tb_exit
  );

  hintname : array [0..33] of string[50] = (
    'Create new file','Open file','',
    'Save file','Save all files','Save file as...','',
    'Cut to clipboard','Copy to clipboard','Paste from clipboard','Delete selection','',
    'Undo','Redo','',
    'Find from file','Find previous','Find next','',
    'Unindent selection','Indent selection','',
    'Setting','Options','',
    'Build source code','Compile source code','Pause running','Stop compiling','',
    'Print file','Select color','',
    'Exit program'
  );

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit1: TEdit;
    ImageList1: TImageList;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuFind: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem12: TMenuItem;
    Panel5: TPanel;
    PMenuUpper: TMenuItem;
    PMenuLower: TMenuItem;
    PMenuSwap: TMenuItem;
    PMenuTitle: TMenuItem;
    MenuItem9: TMenuItem;
    PMenuRedo: TMenuItem;
    MenuItem11: TMenuItem;
    PMenuCut: TMenuItem;
    MenuItem13: TMenuItem;
    PMenuCopy: TMenuItem;
    PMenuPaste: TMenuItem;
    PMenuDelete: TMenuItem;
    MenuItem18: TMenuItem;
    PMenuFind: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem21: TMenuItem;
    PMenuUnindent: TMenuItem;
    PMenuIndent: TMenuItem;
    PMenuSelAll: TMenuItem;
    PMenuDelSel: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    PMenuUndo: TMenuItem;
    MenuPrint: TMenuItem;
    MenuItem3: TMenuItem;
    MenuUndo: TMenuItem;
    MenuRedo: TMenuItem;
    MenuItem16: TMenuItem;
    MenuCut: TMenuItem;
    MenuCopy: TMenuItem;
    MenuPaste: TMenuItem;
    MenuNew: TMenuItem;
    MenuItem20: TMenuItem;
    MenuIndent: TMenuItem;
    MenuUnindent: TMenuItem;
    MenuDelete: TMenuItem;
    MenuPrev: TMenuItem;
    MenuNext: TMenuItem;
    MenuItem26: TMenuItem;
    MenuOpen: TMenuItem;
    MenuItem4: TMenuItem;
    MenuSave: TMenuItem;
    MenuSaveAll: TMenuItem;
    MenuSaveAs: TMenuItem;
    MenuItem8: TMenuItem;
    MenuExit: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Findpanel: TPanel;
    PopupMenu1: TPopupMenu;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Shape1: TShape;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure  FormCreate(Sender: TObject);
    procedure  FormDestroy(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure  MenuItemClick(Sender: TObject);
    procedure Panel5Click(Sender: TObject);
    procedure  TbClick(Sender: TObject);
    procedure  ActionClick(n: integer);
  protected
    procedure  UpdateActions; override;
  private
    { private declarations }
    toolbar    : TXSToolBar;
    infopanel  : TXSPanel;
    prjpanel   : TXSPanel;
    Splitter3  : TSplitter;
    objpanel   : TXSPanel;
    document   : TXSDockManager;
    toolbtn    : array [tb_sep..tb_exit] of TXSToolButton;
  public
    { public declarations }
    pagecontrol: TXSPagecontrol;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  png : TPortableNetworkGraphic;
  rss : TResourceStream;
  i   : integer;
begin
  Doublebuffered := true;

  Width  := Screen.Width - Screen.Width div 4;
  Height := Screen.Height - Screen.Height div 4;

  png:=TPortableNetworkGraphic.Create;
  try
    rss := TResourceStream.Create(HINSTANCE,'Menu',RT_RCDATA);
    try
      png.LoadFromStream(rss);
      ImageList1.Add(png,nil);
    finally
      rss.Free;
    end;
  finally
    png.Free;
  end;

  toolbar := TXSToolBar.Create(Self);
  toolbar.Parent := Self;
  toolbar.Images := ImageList1;

  for i:=low(tlbtn) to high(tlbtn) do begin
    if tlbtn[i]=tb_sep then
      toolbar.AddSeparator
    else if tlbtn[i]=tb_color then
    else begin
      toolbtn[tlbtn[i]] := TXSToolButton.Create(toolbar);
      toolbtn[tlbtn[i]].ImageIndex := tlbtn[i]-1;
      toolbtn[tlbtn[i]].Tag        := tlbtn[i];
      toolbtn[tlbtn[i]].Enabled    := true;
      toolbtn[tlbtn[i]].OnClick    := @TbClick;
      toolbar.AddButton(hintname[i],toolbtn[tlbtn[i]]);
    end;
  end;

  findpanel.Height:=0;

  infopanel  := TXSPanel.Create(Self);
  infopanel.Parent := Panel3;
  infopanel.Align  := alClient;
  infopanel.Images := ImageList1;
  infopanel.ImageIndex:= 27;
  infopanel.Caption   := 'Messages';
  Splitter3 := TSplitter.Create(self);
  Splitter3.Parent := Panel2;
  Splitter3.Align := alTop;
  Splitter3.Height:= 4;
  Splitter3.Color := clSilver;

  prjpanel  := TXSPanel.Create(Self);
  prjpanel.Parent := Panel2;
  prjpanel.Align  := alTop;
  prjpanel.Images := ImageList1;
  prjpanel.ImageIndex:= 25;
  prjpanel.Caption   := 'Project inspector';
  prjpanel.Height    := (height - Panel3.Height - toolbar.Height) div 2;

  objpanel  := TXSPanel.Create(Self);
  objpanel.Parent := Panel2;
  objpanel.Align  := alClient;
  objpanel.Images := ImageList1;
  objpanel.ImageIndex:= 26;
  objpanel.Caption   := 'Object inspector';

  pagecontrol          := TXSpagecontrol.Create(Self);
  pagecontrol.Parent   := Panel5;
  pagecontrol.Align    := alClient;

  document := TXSDockManager.Create(pagecontrol);
  document.DefaultName:= 'Module';
  document.DefaultExt := '.mod';
  document.FileFilter := 'Oberon files (*.mod;*.ob7)|*.mod;*.ob7'
                       +'|Text files (*.txt;*.ini;*.inc)|*.txt;*.ini;*.inc'
                       +'|All files (*.*)|*.*';;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  CanClose := Document.SaveCloseQuery;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(document);
  FreeAndNil(toolbar);
  FreeAndNil(pagecontrol);
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  prjpanel.visible := true;
end;

procedure TForm1.MenuItem6Click(Sender: TObject);
begin
  objpanel.visible := true;
end;

procedure TForm1.MenuItem7Click(Sender: TObject);
begin
  infopanel.visible := true;
end;

procedure TForm1.ActionClick(n: integer);
begin
  case n of
    tb_new      : Document.NewPage;
    tb_open     : Document.OpenPage;
    tb_save     : Document.SaveFile;
    tb_saveall  : Document.SaveAll;
    tb_saveas   : Document.SaveFileAs;
    tb_cut      : Document.Cut;
    tb_copy     : Document.Copy;
    tb_paste    : Document.Paste;
    tb_del      : Document.Delete;
    tb_undo     : Document.Undo;
    tb_redo     : Document.Redo;
    tb_find     : Document.Find;
    tb_findprev : Document.FindPrev;
    tb_findnext : Document.FindNext;
    tb_unindent : Document.Unindent;
    tb_indent   : Document.Indent;
    tb_setting  : ;
    tb_options  : ;
    tb_build    : Document.Build;
    tb_run      : Document.Run;
    tb_pause    : Document.Pause;
    tb_stop     : Document.Stop;
    tb_print    :;
    tb_exit     : Close;

    pm_closepage: Document.ClosePage;
    pm_selall   : Document.SelectAll;
    pm_delsel   : Document.DeleteSelection;
    pm_upper    : Document.Upper;
    pm_lower    : Document.Lower;
    pm_swap     : Document.Swap;
    pm_title    : Document.Title;
  else
    ShowMessage(IntToStr(n));
  end;
end;

procedure TForm1.MenuItemClick(Sender: TObject);
begin
  ActionClick(TMenuItem(Sender).tag);
end;

procedure TForm1.Panel5Click(Sender: TObject);
begin

end;

procedure TForm1.TbClick(Sender: TObject);
begin
  ActionClick(TXSToolButton(Sender).tag);
end;

procedure TForm1.UpdateActions;
var
  flag: boolean;
begin

  flag := Document.pagecontrol.pagelist.count>0;

  findpanel.Visible := flag;

  toolbtn[tb_save].enabled     := flag ;//and (Document.Editor.Modified or (Document.Page.Path=''));
  toolbtn[tb_saveall].enabled  := (pagecontrol.pagelist.count>1) and Document.AllModified;
  toolbtn[tb_saveas].enabled   := flag;

  toolbtn[tb_cut].enabled      := flag and Document.Editor.SelAvail;
  toolbtn[tb_copy].enabled     := flag and Document.Editor.SelAvail;
  toolbtn[tb_paste].enabled    := flag and (Clipboard.AsText<>'');
  toolbtn[tb_del].enabled      := flag and Document.Editor.SelAvail;

  toolbtn[tb_undo].enabled     := flag and Document.Editor.CanUndo;
  toolbtn[tb_redo].enabled     := flag and Document.Editor.CanRedo;

  toolbtn[tb_find].enabled     := flag and (Document.Editor.Text<>'');
  toolbtn[tb_findprev].enabled := false;
  toolbtn[tb_findnext].enabled := false;

  toolbtn[tb_unindent].enabled := flag and Document.Editor.SelAvail;
  toolbtn[tb_indent].enabled   := flag and Document.Editor.SelAvail;

  toolbtn[tb_setting].enabled  := true;
  toolbtn[tb_options].enabled  := true;

  toolbtn[tb_build].enabled    := false;
  toolbtn[tb_run].enabled      := flag and (Document.Editor.Text<>'');
  toolbtn[tb_pause].enabled    := false;
  toolbtn[tb_stop].enabled     := false;

  toolbtn[tb_print].enabled    := false;
  //toolbtn[tb_color].enabled    := false;

  toolbtn[tb_exit].enabled     := true;

  MenuSave.enabled             := toolbtn[tb_save].enabled;
  MenuSaveall.enabled          := toolbtn[tb_saveall].enabled;
  MenuSaveas.enabled           := toolbtn[tb_saveas].enabled;
  Menuprint.enabled            := toolbtn[tb_print].enabled;

  Menucut.enabled              := toolbtn[tb_cut].enabled;
  Menucopy.enabled             := toolbtn[tb_copy].enabled;
  Menupaste.enabled            := toolbtn[tb_paste].enabled;
  Menudelete.enabled           := toolbtn[tb_del].enabled;
  Menuundo.enabled             := toolbtn[tb_undo].enabled;
  Menuredo.enabled             := toolbtn[tb_redo].enabled;
  Menufind.enabled             := toolbtn[tb_find].enabled;
  Menuprev.enabled             := toolbtn[tb_findprev].enabled;
  Menunext.enabled             := toolbtn[tb_findnext].enabled;
  Menuunindent.enabled         := toolbtn[tb_unindent].enabled;
  Menuindent.enabled           := toolbtn[tb_indent].enabled;

  PMenucut.enabled             := toolbtn[tb_cut].enabled;
  PMenucopy.enabled            := toolbtn[tb_copy].enabled;
  PMenupaste.enabled           := toolbtn[tb_paste].enabled;
  PMenudelete.enabled          := toolbtn[tb_del].enabled;
  PMenuundo.enabled            := toolbtn[tb_undo].enabled;
  PMenuredo.enabled            := toolbtn[tb_redo].enabled;
  PMenufind.enabled            := toolbtn[tb_find].enabled;
  PMenuunindent.enabled        := toolbtn[tb_unindent].enabled;
  PMenuindent.enabled          := toolbtn[tb_indent].enabled;

  PMenuSelAll.enabled          := flag and (Document.Editor.Text<>'');
  PMenuDelSel.enabled          := flag and Document.Editor.SelAvail;

  PMenuUpper.enabled           := flag and Document.Editor.SelAvail;
  PMenuLower.enabled           := flag and Document.Editor.SelAvail;
  PMenuSwap.enabled            := flag and Document.Editor.SelAvail;
  PMenuTitle.enabled           := flag and Document.Editor.SelAvail;

  Panel3.Visible               := infopanel.Visible;
  Splitter1.Visible            := Panel3.Visible;

  Panel2.Visible               := prjpanel.Visible or objpanel.Visible;
  Splitter3.Visible            := prjpanel.Visible and objpanel.Visible;
  Splitter2.Visible            := Panel2.Visible;

end;

end.

